	SUBROUTINE MATRHO
************************************************************
*   Find charge density according to Mattheiss procedure.  *
*   Written by S.Yu.Savrasov in Max-Planck-Institut, FRG.  *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,ILSV(NSORTMAX),NHSORT(NSORTMAX),NRAD(NSORTMAX)
     &   ,LMSYM(LMMAXV,NPAT),NSYM(NPAT),MIN(NSORTMAX)
     &   ,MAX(NSORTMAX)
	DIMENSION H(NSORTMAX),R(0:NRADMAX,NSORTMAX)
     &   ,DR(0:NRADMAX,NSORTMAX),Z(NSORTMAX),ZCOR(NSORTMAX)
     &   ,WEIGHT(0:NRADMAX,NSORTMAX),SMT(NSORTMAX),HLIB(NSORTMAX)
     &   ,RLIB(0:631,NSORTMAX),ROCOR(0:NRADMAX,NSORTMAX)
     &   ,DERIN(0:NRADMAX,2),DEROUT(0:631,2),SASA(NSORTMAX)
     &   ,ROCR(0:631),ROCI(0:631),WORK1(0:NRADMAX,2)
     &   ,ROATOM(0:631,NSORTMAX),ROCATOM(0:631,NSORTMAX)
     &   ,WX(0:631),WY(0:631),WZ(0:631),RHOT(5)
	COMPLEX*16 RO(0:NRADMAX,NSYMMAX,NPAT)
     &   ,ROLIB(0:631,NSYMMAX,NPAT),ROVALDS(3,NSYMMAX,NPAT)
	LOGICAL SYM(LMMAXV,NPAT)
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT  !!! from init
	COMMON /RADMESH/ NRAD,H,R,DR,WEIGHT                    !!! from radmsh
	COMMON /DENS/    RO,ROVALDS,ROCOR                      !!! from rofull
	COMMON /MULTRO/  Z,ZCOR                                !!! from init
	COMMON /SYMMLM/  SYM,LMSYM,NSYM                        !!! from symmlm
	COMMON /STORE1/  ROLIB                                 !!! from matcor
	COMMON /LIBMESH/ NLIB,HLIB,RLIB                        !!! from libmsh
	COMMON /ASASPH/  SASA                                  !!! from init
	COMMON /CORE/    ROATOM,ROCATOM                        !!! from init
	COMMON /POTCOM/  SWZ,SMT                               !!! from init
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
C GET STARTING AND END POINTS
	DO 30 IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO 5 IRAD=0,NLIB
	ROLIB(IRAD,1,IATOM)=ROATOM(IRAD,ISORT)
	DO 5 ISYM=2,NSYM(IATOM)
	ROLIB(IRAD,ISYM,IATOM)=(0.D0,0.D0)
   5    CONTINUE
	DO 10 IRAD=0,NLIB
	IF(RLIB(IRAD,ISORT).LT.0.5D0*SMT(ISORT))MIN(ISORT)=IRAD
	IF(ABS(RLIB(IRAD,ISORT)-SMT(ISORT)).LE.1.D-10)MID=IRAD
	IF(RLIB(IRAD,ISORT).GT.SMT(ISORT))GOTO 20
  10    CONTINUE
  20    MAX(ISORT)=IRAD
  30    CONTINUE
C  PERFORM SUMMMATION OF THE ATOMIC DENSITIES
	CALL MATCOR(MIN,MAX)
C  RETURN TO THE OLD MESH FOR THE FULL CHARGE DENSITY
	DO 80 IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO 70 ISYM=1,NSYM(IATOM)
	DO 40 I=0,NLIB
	ROCR(I)=DREAL(ROLIB(I,ISYM,IATOM))
	ROCI(I)=DIMAG(ROLIB(I,ISYM,IATOM))
 40     CONTINUE
	CALL SPLIN3(RLIB(0,ISORT),ROCR(0),DEROUT,MAX(ISORT)+1,632,
     &  R(0,ISORT),WORK1(0,1),DERIN,NRAD(ISORT)+1,NRADMAX+1,-1)
	CALL SPLIN3(RLIB(0,ISORT),ROCI(0),DEROUT,MAX(ISORT)+1,632,
     &  R(0,ISORT),WORK1(0,2),DERIN,NRAD(ISORT)+1,NRADMAX+1,-1)
	DO 50 IRAD=0,NRAD(ISORT)
	RO(IRAD,ISYM,IATOM)=DCMPLX(WORK1(IRAD,1),WORK1(IRAD,2))
	ROCOR(IRAD,ISORT)=(0.D0,0.D0)
 50     CONTINUE
 70     CONTINUE
 80     CONTINUE
C  RETURN TO THE OLD MESH FOR THE CORE CHARGE DENSITY
	DO 220 ISORT=1,NSORT
	DO 200 I=0,NLIB
	ROCR(I)=ROCATOM(I,ISORT)*SQPI4
 200    CONTINUE
	CALL SPLIN3(RLIB(0,ISORT),ROCR(0),DEROUT,MAX(ISORT)+1,632,
     &  R(0,ISORT),WORK1(0,1),DERIN,NRAD(ISORT)+1,NRADMAX+1,-1)
	DO 210 IRAD=0,NRAD(ISORT)
	ROCOR(IRAD,ISORT)=DCMPLX(WORK1(IRAD,1),0.D0)
 210    CONTINUE
 220    CONTINUE
	END





	SUBROUTINE MATCOR(MIN,MAX)
***************************************************************
*  Perform a summation of the core charge tails over lattice  *
***************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (NSITMAX=200)
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,ICOR(NSORTMAX),ILSV(NSORTMAX),NHSORT(NSORTMAX)
     &   ,MAX(NSORTMAX),NSYM(NPAT),IREF(NSITMAX,NPAT),NSITE(NPAT)
     &   ,LMSYM(LMMAXV,NPAT),MIN(NSORTMAX)
	DIMENSION RLIB(0:631,NSORTMAX),SMT(NSORTMAX)
     &   ,WORK(0:631,NSYMMAX),WORK1(0:631,NPAT),DERIV(0:631,2,NPAT)
     &   ,A(3),B(3),C(3),TAUT(3,NPAT),TAU(3,NPAT),ANSW(NSYMMAX)
     &   ,WORK2(0:631),POL(0:LMAXV),FDERIV(0:631,2),RNEW(0:631)
     &   ,ROCNEW(0:631),Z(NSORTMAX),ZCOR(NSORTMAX)
     &   ,HLIB(NSORTMAX),DELTA(NSITMAX,NPAT)
	COMPLEX*16 ROLIB(0:631,NSYMMAX,NPAT)
     &   ,CL,DL,DRODR,DIML,WD(NSITMAX,NSYMMAX,NPAT)
	LOGICAL SYM(LMMAXV,NPAT)
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT  !!! from init
	COMMON /POTCOM/  SWZ,SMT                               !!! from init
	COMMON /LATTICE/ A,B,C                                 !!! from init
	COMMON /BASIS/   TAU                                   !!! from init
	COMMON /MULTRO/  Z,ZCOR                                !!! from init
	COMMON /DENS/    WD,WORK,WORK1,DERIV                   !!! tmp.storage
	COMMON /STORE1/  ROLIB                                 !!! from matcor
	COMMON /LIBMESH/ NLIB,HLIB,RLIB                        !!! from libmsh
	COMMON /SYMMLM/  SYM,LMSYM,NSYM                        !!! from symmlm
	COMMON /LATPAR/  PAR                                   !!! from init
	COMMON /UNIT/    IUN
	LOGICAL FIRST
	SAVE FIRST,DELTA,IREF,NSITE
	DATA FIRST/.TRUE./,PI/3.141592653589793D0/,C2/0.000013312838D0/
	SQPI4=2.D0*SQRT(PI)
	IF(FIRST)CALL SETSITES(DELTA,IREF,NSITE)
	FIRST=.FALSE.
C  CALCULATE SPLINE COEFFICIENTS FOR THE CORE DENSITY
	DO 20 IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO 10 IRAD=0,NLIB
	WORK1(IRAD,IATOM)=DREAL(ROLIB(IRAD,1,IATOM))
	ROLIB(IRAD,1,IATOM)=ROLIB(IRAD,1,IATOM)*SQPI4
  10    CONTINUE
	CALL SPLIN3(RLIB(0,ISORT),WORK1(0,IATOM),DERIV(0,1,IATOM),
     &  NLIB+1,632,0.D0,0.D0,0.D0,0,1,-1)
  20    CONTINUE
C *** CALCULATE TAIL CONTRIBUTION TO THE CORE DENSITY ***
	DO 100 IATOM=1,NATOM
	XMAX=LOG(60.D0)
	XMIN=XMAX-DBLE(NLIB-1)*HLIB(ISORT)
	COEF=EXP(XMIN-HLIB(ISORT))
	ISORT=IS(IATOM)
	DO 80 ISITE=1,NSITE(IATOM)
	JATOM=IREF(ISITE,IATOM)
	JSORT=IS(JATOM)
	IF(ABS(Z(JSORT)).LE.1.D-05)GOTO80   !!! empty sphere case
	IF(DELTA(ISITE,IATOM).EQ.0.D0)GOTO80
	DO 70 IRAD=1,MAX(ISORT)
C  MAKE A GRID FOR TAKING THE INTEGRALS
	RMD=ABS(DELTA(ISITE,IATOM)-RLIB(IRAD,ISORT))
	RPD=    DELTA(ISITE,IATOM)+RLIB(IRAD,ISORT)
	RIMIN=LOG(RMD/COEF)/HLIB(ISORT)     !!! real lower limit point
	RIMAX=LOG(RPD/COEF)/HLIB(ISORT)     !!! real upper limit point
	IRAD1=    (RIMIN)                   !!! integer lower point
	IRAD2=NINT(RIMAX)
	NUM=IRAD2-IRAD1
	NUM=((NUM+1)/2)*2+10                !!! number of points
	IRAD2=NUM+IRAD1                     !!! integer upper point
	IF(IRAD.LT.MIN(ISORT))ILMAX=0
	IF(IRAD.GE.MIN(ISORT))ILMAX=ILSV(ISORT)
	HNEW=LOG(RPD/RMD)/DBLE(NUM)
	CNEW=RMD*EXP(-HNEW*IRAD1)
C  MAKE THE INTEGRAND
	DO 40 I=IRAD1,IRAD2
	RNEW(I)=CNEW*EXP(HNEW*I)
	XPNT=0.5D0*(RLIB(IRAD,ISORT)**2+DELTA(ISITE,IATOM)**2-
     &  RNEW(I)**2)/(RLIB(IRAD,ISORT)*DELTA(ISITE,IATOM))
	CALL LEGPOL(POL,XPNT,ILMAX)
	LP=-1
	DO 30 L=0,ILMAX
	DO 30 M=-L,L
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	IF(LP.EQ.L)GOTO30
	WORK(I,ISYM)=RNEW(I)*POL(L)*RNEW(I)
	LP=L
	ENDIF
  30    CONTINUE
  40    CONTINUE
	CALL SPLIN3(RLIB(0,JSORT),WORK1(0,JATOM),DERIV(0,1,JATOM),
     &  NLIB+1,632,RNEW(IRAD1),ROCNEW(IRAD1),FDERIV,NUM+1,632,+1)
	LP=-1
	DO 55 L=0,ILMAX
	DO 50 M=-L,L
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	IF(LP.NE.L)THEN
	DO 45 I=IRAD1,IRAD2
	WORK(I,ISYM)=WORK(I,ISYM)*ROCNEW(I)
  45    CONTINUE
	CALL QD(HNEW,WORK(IRAD1,ISYM),WORK2(IRAD1),NUM+1)
	ANSW(ISYM)=WORK2(IRAD2)
	LP=L
	ISYMP=ISYM
	ELSE
	ANSW(ISYM)=ANSW(ISYMP)
	ENDIF
	ENDIF
  50    CONTINUE
  55    CONTINUE
	DO 60 L=0,ILMAX
	DIML=(0.D0,1.D0)**(-L)
	DO 60 M=-L,L
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	ROLIB(IRAD,ISYM,IATOM)=ROLIB(IRAD,ISYM,IATOM)+
     &  2.D0*PI/RLIB(IRAD,ISORT)/DELTA(ISITE,IATOM)*ANSW(ISYM)*
     &  WD(ISITE,ISYM,IATOM)*DIML    
	ENDIF
  60    CONTINUE
  70    CONTINUE
  80    CONTINUE
C  SET TAIL-PART AT THE CENTER OF ATOM
	ROLIB(0,1,IATOM)=ROLIB(1,1,IATOM)
     & -(ROLIB(2,1,IATOM)-ROLIB(1,1,IATOM))/
     &  (RLIB(2,ISORT)-RLIB(1,ISORT))*RLIB(1,ISORT)
C  EXTRAPOLATE NON-SPHERICAL PART TO THE NUCLEUS
	IRAD0=MIN(ISORT)
	DO 90 L=1,ILSV(ISORT)
	DO 90 M=-L,L
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	DEG=SQRT(L*(L+1)+1.D0-4.D0*Z(ISORT)*C2)
	DRODR=(ROLIB(IRAD0+1,ISYM,IATOM)-ROLIB(IRAD0,ISYM,IATOM))/
     &       (RLIB(IRAD0+1,ISORT)-RLIB(IRAD0,ISORT))
	CL=-1.D0/RLIB(IRAD0,ISORT)**(DEG-2.D0)*(DRODR-DEG
     &        /RLIB(IRAD0,ISORT)*ROLIB(IRAD0,ISYM,IATOM))
	DL=+1.D0/RLIB(IRAD0,ISORT)**(DEG-1.D0)*(DRODR-(DEG-1.D0)
     &        /RLIB(IRAD0,ISORT)*ROLIB(IRAD0,ISYM,IATOM))
	DO 85 IRAD=0,MIN(ISORT)
	ROLIB(IRAD,ISYM,IATOM)=CL*RLIB(IRAD,ISORT)**(DEG-1)
     &                         +DL*RLIB(IRAD,ISORT)**DEG
  85    CONTINUE
	ENDIF
  90    CONTINUE
 100    CONTINUE
	END


	SUBROUTINE LEGPOL(P,X,LMAX)
*********************************************************
*  Calculate Legandere polynoms up to l equal to Lmax   *
*********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION P(0:LMAX)
	P(0)=1.D0
	IF(LMAX.EQ.0)RETURN
	P(1)=X
	DO 10 L=1,LMAX-1
	A=DBLE(2*L+1)/DBLE(L+1)
	B=DBLE(  L  )/DBLE(L+1)
	P(L+1)=A*X*P(L)-B*P(L-1)
  10    CONTINUE
	END




	SUBROUTINE SETSITES(DELTA,IRS,NS)
***********************************************************************
*   Set nearest site distances for every kind of atom.                *
***********************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (NSITMAX=200)
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,ILSV(NSORTMAX),NHSORT(NSORTMAX),IREF(NVCMAX)
     &    ,IRS(NSITMAX,NPAT),NS(NPAT),NSYM(NPAT),LMSYM(LMMAXV,NPAT)
	DIMENSION SITE(3,NVCMAX),A(3),B(3),C(3)
     &    ,TAUT(3,NPAT),TAU(3,NPAT),DELTA(NSITMAX,NPAT)
	COMPLEX*16 WD(NSITMAX,NSYMMAX,NPAT),YLM(LMMAXV)
	LOGICAL SYM(LMMAXV,NPAT)
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT  !!! from init
	COMMON /LATTICE/ A,B,C                                 !!! from init
	COMMON /BASIS/   TAU                                   !!! from init
	COMMON /DENS/    WD                                    !!! from setsites
	COMMON /RADIUS/  RADIUS                                !!! from main
	COMMON /SYMMLM/  SYM,LMSYM,NSYM                        !!! from symmlm
	COMMON /LATPAR/  PAR                                   !!! from init
	COMMON /UNIT/    IUN
	DO 60 IATOM=1,NATOM
	ISORT=IS(IATOM)
C  CALCULATE ALL VECTORS CONTAINING IN A SPHERE SURROUNDING GIVEN ATOM
	RMAX=RADIUS/PAR+1.D-05
	DO 20 JATOM=1,NATOM
	DO 10 IC=1,3
	TAUT(IC,JATOM)=TAU(IC,JATOM)-TAU(IC,IATOM)
  10    CONTINUE
  20    CONTINUE
	CALL SITEGEN(RMAX,A,B,C,TAUT,NATOM,NSITE,SITE,IREF)
C  SORT VECTORS ACCORDING TO THEIR LENGTH
	ISN=0
	DO 50 ISITE=1,NSITE
	DELS=SQRT(SITE(1,ISITE)**2+SITE(2,ISITE)**2+SITE(3,ISITE)**2)
	IF(DELS.EQ.0.D0)GOTO50
	DELX=SITE(1,ISITE)/DELS
	DELY=SITE(2,ISITE)/DELS
	DELZ=SITE(3,ISITE)/DELS
C  FIND SPHERICAL HARMONICS (WIGNER'S MATRICES WHEN M=0)
	CALL SPHHARM(DELX,DELY,DELZ,ILSV(ISORT),YLM)
	KEY=1
C  COMPARE WITH PREVIOUS VECTORS
	DO 40 JSN=1,ISN
	IF(DELTA(JSN,IATOM).EQ.DELS*PAR.AND.IRS(JSN,IATOM).EQ.
     &  IREF(ISITE))THEN
	KEY=0
	DO 30 LM=1,(ILSV(ISORT)+1)**2
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	WD(JSN,ISYM,IATOM)=WD(JSN,ISYM,IATOM)+CONJG(YLM(LM))
	ENDIF
  30    CONTINUE
	GOTO 50
	ENDIF
  40    CONTINUE
	IF(KEY.NE.1)GOTO 50
C  IF NONE ADD TO ARRAY
	ISN=ISN+1
	IF(ISN.GT.NSITMAX)STOP'<SETSITES> SUBSCRIPT OUT OF BOUNDS,
     &  DECREASE RADIUS OF SUMMATION OR INCREASE PARAMETER NSITMAX
     &  INSIDE THE PROGRAM'
	DELTA(ISN,IATOM)=DELS*PAR
	DO 45 LM=1,(ILSV(ISORT)+1)**2
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	WD(ISN,ISYM,IATOM)=CONJG(YLM(LM))
	ENDIF
  45    CONTINUE
	IRS(ISN,IATOM)=IREF(ISITE)
  50    CONTINUE
	NS(IATOM)=ISN
  60    CONTINUE
	END
