	SUBROUTINE RENROV
****************************************************************
*  Renormalize valence density according to the input charge   *
*  Written by S.Yu.Savrasov (P.N.Lebedev Physical Institute)   *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILSV(NSORTMAX),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT)
     &    ,NRAD(NSORTMAX)
	DIMENSION SMT(NSORTMAX),Z(NSORTMAX),ZCOR(NSORTMAX)
     &    ,H(NSORTMAX),R(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &    ,WEIGHT(0:NRADMAX,NSORTMAX),WORK1(0:NRADMAX),WORK2(0:NRADMAX)
     &    ,RL(0:NRADMAX,0:LMAXV,NSORTMAX),AD(3,3),RD(3,3)
     &    ,ROCOR(0:NRADMAX,NSORTMAX),ORTH(2:3)
	COMPLEX*16 DIM,ROVALDS(3,NSYMMAX,NPAT)
     &    ,RO(0:NRADMAX,NSYMMAX,NPAT),ROVAL
	LOGICAL SYM(LMMAXV,NPAT)
	CHARACTER TXTEL(NSORTMAX)*10
	COMMON /CONTROL/MAN,LMTO,NLR,NOVR                   !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /DENS/   RO,ROVALDS,ROCOR                    !!! from rofull
	COMMON /PSRHO/  RHOPS                               !!! from init
	COMMON /POTCOM/ SWZ,SMT                             !!! from init
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                     !!! from init
	COMMON /MULTRO/ Z,ZCOR                              !!! from init
	COMMON /SYMMLM/ SYM,LMSYM                           !!! from symlm
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL               !!! from radmsh
	COMMON /UNIT/   IUN                                 !!! from init
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
	SQPI4=2.D0*SQRT(PI)
	ZVMTS=0.D0
	ZVALT=0.D0
	DO 30 IATOM=1,NATOM                   !!! over atoms
	ISORT=IS(IATOM)
C  FIND CHARGES WITHIN MTS
	DO 10 IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=RO(IRAD,1,IATOM)*WEIGHT(IRAD,ISORT)/
     &  SQRT(4.D0*PI)
  10    CONTINUE
	CALL QD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	ZVMTS=ZVMTS+WORK2(NRAD(ISORT))
	ZVALT=ZVALT+Z(ISORT)
  30    CONTINUE                              !!! over atoms
C FIND PSEUDOCHARGE
	ZVINT=0.D0
	ZVTOT=ZVMTS+ZVINT
	IF(ABS(ZVTOT).LE.1.D-10)
     &  STOP'<RENROV>: INTERNAL ERROR, VALENCE CHARGE IS ZERO'
	ANORM=ZVALT/ZVTOT
	WRITE(IUN,1010)ZVALT
	WRITE(IUN,1020)ZVTOT
	WRITE(IUN,1030)ANORM
C RENORMALZATIONS
        DO IATOM=1,NATOM
        ISORT=IS(IATOM)
        DO IRAD=0,NRAD(ISORT)
        RO(IRAD,1,IATOM)=RO(IRAD,1,IATOM)*ANORM
        ENDDO
        ENDDO
1010    FORMAT(1X,'Total charge in whole  elementary cell  must be ',
     &  G14.7)
1020    FORMAT(1X,'Total charge  found  via fourier  transform  is ',
     &  G14.7)
1030    FORMAT(1X,'Renormalization coefficient of total density is ',
     &  G14.7)
	END
