	SUBROUTINE BANDS
****************************************************************
*   Control module for package of programs solved generalized  *
*         eigenvalue problem of the LMTO method                *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER NPNT(NPANMAX)
	COMMON /KAPPAR/ NPAN
	COMMON /SPIN/   NSPIN
	COMMON /MESH/   NPNT
	COMMON /UNIT/   IUN
C ** COMPUTE EIGENVALUES AND EIGENVECTORS ***
	DO IPAN=1,NPAN           !!! over panels
	CALL SNULTOS(IPAN)       !!! set tos-matrix to zero
	CALL SSETENY(IPAN)       !!! place Eny somewhere
	CALL SCORENY(IPAN)       !!! find binding energies for semicore
	CALL SPOTPAR(IPAN)       !!! different potential partameters
	CALL SKKRPAR(IPAN)       !!! KKR-partameters (only to print)
	CALL SPRIPAR(IPAN)       !!! print potential parameters
	CALL SLMTPAR(IPAN)       !!! some combinations of parameters
	CALL SOVRPAR(IPAN)       !!! potential parameters for overlapping
	CALL SNMTPAR(IPAN)       !!! NMT potential parameters
	CALL SHUBPAR(IPAN)       !!! Hubbard corrections
 	CALL SORBPAR(IPAN)       !!! SO-coupling parameters
	DO IPNT=1,NPNT(IPAN)     !!! over k-points
	CALL STRSUM(IPNT,IPAN)   !!! calculate lattice sums
	CALL STRGNT(IPNT,IPAN)   !!! restore bare structure matrices
	CALL STRALP(IPNT,IPAN)   !!! screen structure constants
	CALL SCRSTR(IPNT,IPAN)   !!! restore screened structure constants
	CALL LMTMAT(IPNT,IPAN)   !!! hamiltonian and overlap from MTS
 	CALL ORBMAT(IPNT,IPAN)   !!! SO-couping in the hamitonian
 	CALL GETHTB(IPNT,IPAN)   !!! get tight-binding parameters
	CALL LMTBND(IPNT,IPAN)   !!! solve eigenvalue problem
	CALL TOSPAR(IPNT,IPAN,0) !!! BZ-integrals from the occupied states
	CALL FATBND(IPNT,IPAN)   !!! tlm-characters to plot fat bands
        ENDDO                    !!! over k-points
	CLOSE(13,STATUS='DELETE')!!! close scratch file opened in NMTPAR
        ENDDO                    !!! over panels
	END
