	SUBROUTINE BZINT
****************************************************
*  Calculate BZ integrals and find Fermi energy    *
****************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),NBNDF(NPANMAX),NBNDE(NPANMAX)
     &   ,NBNDT(NPANMAX)
	DIMENSION  Z(NSORTMAX),ZCOR(NSORTMAX),VEL(3)
     &   ,SPDOS(NSPINMAX),SPVEL(3,NSPINMAX)
	CHARACTER*10 TXTEL(NSORTMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from init
	COMMON /MULTRO/ Z,ZCOR                               !!! from init
	COMMON /EFERMI/ EF                                   !!! Fermi energy
	COMMON /KAPPAR/ NPAN                                 !!! frin init
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! from init
	COMMON /UNIT/   IUN                                  !!! from init
	COMMON /TXTEL/  TXTEL                                !!! from init
	DATA PI/3.141592653589793D0/
	ZVAL=0.0
	DO ISORT=1,NSORT                   !!! define total valence charge
	ZVAL=ZVAL+(Z(ISORT)-ZCOR(ISORT))*NHSORT(ISORT)
	ENDDO 
	ZSEM=0.D0
	DO IPAN=2,NPAN                     !!! define semicore charge
	ZSEM=ZSEM+2.D0*NBNDT(IPAN)
	ENDDO 
	CALL EFINS(EF,ZVAL-ZSEM)           !!! recognize insulating case
	CALL EFSEARCH(EF,ZVAL-ZSEM,EF)     !!! search for Fermi energy
	CALL TTRVEL(EF,DOS,VEL,SPDOS,SPVEL)!!! electron velocities at EF
	CALL TTRINT2(EF)                   !!! get partial numbers states
	CALL SNBANDS(EF)                   !!! define # of filled bands
	CALL LRBANDS(EF)                   !!! define # of bands for LR
	END



	SUBROUTINE EFINS(EF,ZVAL)
***********************************************************
*  Recognizes insulating case.                            *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX),NPNT(NPANMAX)
	DIMENSION EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM
	COMMON /ENERGY/ EARR                                 !!! from lmtbnd
	COMMON /MESH/   NPNT                                 !!! from ttrmsh
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! # of bands
	COMMON /ORBS/   NORBS                                !!! from init
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /UNIT/   IUN                                  !!! output unit
	DATA PI/3.141592653589793D0/
	IF(ABS(MOD(ZVAL,2.D0)).GE.1.D-10)RETURN
	NB=ZVAL/2.D0
	EVMAX=EARR(1,1,1)
	EEMIN=EARR(NBNDT(1)*NSPIN,1,1)
	DO IPNT=1,NPNT(1)
	DO IV=1,NB
	DO IBNDS=1,NSPIN
	IBAND=IBNDS+NSPIN*(IV-1)
	EVMAX=MAX(EVMAX,EARR(IBAND,IPNT,1))
	ENDDO
	ENDDO
	DO IE=NB+1,NBNDT(1)
	DO IBNDS=1,NSPIN
	IBAND=IBNDS+NSPIN*(IE-1)
	EEMIN=MIN(EEMIN,EARR(IBAND,IPNT,1))
	ENDDO
	ENDDO
	ENDDO
	GAP=EEMIN-EVMAX
	IF(GAP.LE.0.D0)RETURN
	EF=EVMAX+1.D-06
	WRITE(IUN,1010)
	WRITE(IUN,1020)GAP,GAP*13.6058D0
1010    FORMAT(1X,'Semiconducting band structure discovered --------->')
1020    FORMAT(1X,'dielectric gap value is ',G14.7,' Ry ; ',G14.7,' eV')
	END






	SUBROUTINE SNBANDS(EF)
*************************************************
*   Define a number of filled and empty bands   *
*************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &    ,NBNDEMP(2),NBNDFIL(2),NPNT(NPANMAX)
	DIMENSION EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX)
     &    ,PNT(3,KMAX,NPANMAX)
	CHARACTER TXTEL(NSORTMAX)*10,TXTSP(2)*2
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT
	COMMON /KAPPAR/ NPAN
	COMMON /ENERGY/ EARR
	COMMON /ORBS/   NORBS
	COMMON /SPIN/   NSPIN
	COMMON /MESH/   NPNT,PNT
	COMMON /UNIT/   IUN
	COMMON /TXTEL/  TXTEL,TXTSP
C DEFINE # OF FILLED BANDS IF THERE IS NO SPIN-ORBIT COUPLING
	IF(NORBS.EQ.1)THEN
	DO IBNDS=1,NSPIN
	NBNDEMP(IBNDS)=0
	NBNDFIL(IBNDS)=0
	DO IBNDT=1,NBNDT(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	N1=0
	N2=0
	DO IPNT=1,NPNT(1)
	IF(EARR(IBAND,IPNT,1).LT.EF)THEN
	N1=IBNDT
	ELSEIF(EARR(IBAND,IPNT,1).GE.EF)THEN
	N2=IBNDT
	ENDIF
	ENDDO 
	IF(N1.NE.0.AND.N2.EQ.0)THEN
	NBNDEMP(IBNDS)=N1+1
	ELSEIF(N1.EQ.0.AND.N2.NE.0)THEN
	NBNDFIL(IBNDS)=N2-1
	EXIT
	ENDIF
        ENDDO   
        ENDDO    
	MBNDFIL=MAX(NBNDFIL(1),NBNDFIL(NSPIN))
	MBNDEMP=MIN(NBNDEMP(1),NBNDEMP(NSPIN))
C DEFINE # OF FILLED BANDS IF THERE IS SPIN-ORBIT COUPLING
	ELSEIF(NORBS.EQ.2)THEN
	MBNDEMP=0
	MBNDFIL=0
	DO IBAND=1,NBNDT(1)*NSPIN
	N1=0
	N2=0
	DO IPNT=1,NPNT(1)
	IF(EARR(IBAND,IPNT,1).LT.EF)THEN
	N1=IBAND
	ELSEIF(EARR(IBAND,IPNT,1).GT.EF)THEN
	N2=IBAND
	ENDIF
	ENDDO
	IF(N1.NE.0.AND.N2.EQ.0)THEN
	MBNDEMP=N1+1
	ELSEIF(N1.EQ.0.AND.N2.NE.0)THEN
	MBNDFIL=N2-1
	EXIT
	ENDIF
        ENDDO   
	IF(MOD(MBNDFIL,2).NE.0)MBNDFIL=MBNDFIL-1
	IF(MOD(MBNDEMP,2).NE.0)MBNDEMP=MBNDEMP+1
	IF(MBNDFIL.LT.0)MBNDFIL=0
	MBNDFIL=MBNDFIL/2
	MBNDEMP=MBNDEMP/2
	ENDIF
	IF(NBNDF(1).LT.MBNDFIL)PRINT*,'# of filled bands mismatches'
	IF(NBNDE(1).GT.MBNDEMP)PRINT*,'# of empty  bands mismatches'
	WRITE(IUN,1010)MBNDEMP-1,NBNDE(1)-1
	WRITE(IUN,1020)MBNDFIL-MBNDEMP+1,NBNDF(1)-NBNDE(1)+1
C       IF(NBNDF(1).LT.MBNDFIL.OR.NBNDE(1).GT.MBNDEMP)STOP
C    &  'Correct NFF and/or NEF in INIFILE and run the task again'
C  PRINT BANDS AT THE G-POINT
	IPNTG=0
	DO IPNT=1,NPNT(1)
	ABSPNT=SQRT(PNT(1,IPNT,1)**2+PNT(2,IPNT,1)**2+PNT(3,IPNT,1)**2)
	IF(ABSPNT.LE.1.D-04)IPNTG=IPNT
	ENDDO
	IF(IPNTG.NE.0.AND.NORBS.EQ.1)THEN
	DO IBNDS=1,NSPIN
	IF(NSPIN.EQ.1)WRITE(IUN,1030)
	IF(NSPIN.EQ.2)WRITE(IUN,1040)TXTSP(IBNDS)
	WRITE(IUN,1050)(EARR(IBNDS+NSPIN*(IBNDT-1),IPNTG,1),
     &  IBNDT=1,NBNDT(1))
        ENDDO   
	ELSEIF(IPNTG.NE.0.AND.NORBS.EQ.2)THEN
	WRITE(IUN,1030)
	WRITE(IUN,1050)((EARR(IBNDS+NSPIN*(IBNDT-1),IPNTG,1),
     &  IBNDS=1,NSPIN),IBNDT=1,NBNDT(1))
	ENDIF
1010    FORMAT(1X,'# of fully filled bands =',I4,'; input # =',I4)
1020    FORMAT(1X,'# of bands crossing Ef  =',I4,'; input # =',I4)
1030    FORMAT(1X,'Energy bands at the Gamma-point are')
1040    FORMAT(1X,'Energy bands at the Gamma-point for spin-',
     &  A2,' states are')
1050    FORMAT(1X,5(G12.5,1X))
	END



	SUBROUTINE LRBANDS(EF)
***********************************************************
*  Prints the bands within +/- 0.5 Ry window from Ef.     *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX),NPNT(NPANMAX)
     &    ,NBNDFIL(2),NBNDEMP(2)
	DIMENSION EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM
	COMMON /ENERGY/ EARR                                 !!! from lmtbnd
	COMMON /MESH/   NPNT                                 !!! from ttrmsh
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! # of bands
	COMMON /ORBS/   NORBS                                !!! from init
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /UNIT/   IUN                                  !!! output unit
	DATA PI/3.141592653589793D0/
	WINDOW=0.5 ! Ry
C DEFINE # OF FILLED BANDS IF THERE IS NO SPIN-ORBIT COUPLING
	IF(NORBS.EQ.1)THEN
	DO IBNDS=1,NSPIN
	NBNDFIL(IBNDS)=0
	DO IBNDT=1,NBNDT(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	IWINF=0
	DO IPNT=1,NPNT(1)
	IF(EARR(IBAND,IPNT,1).LT.EF-WINDOW)IWINF=IWINF+1
	ENDDO 
	IF(IWINF.EQ.NPNT(1))NBNDFIL(IBNDS)=IBNDT
	ENDDO
	NBNDEMP(IBNDS)=NBNDT(1)+1
	DO IBNDT=NBNDT(1),1,-1
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	IWINE=0
	DO IPNT=1,NPNT(1)
	IF(EARR(IBAND,IPNT,1).GT.EF+WINDOW)IWINE=IWINE+1
	ENDDO 
	IF(IWINE.EQ.NPNT(1))NBNDEMP(IBNDS)=IBNDT
	ENDDO
	ENDDO
	MBNDFIL=MAX(NBNDFIL(1),NBNDFIL(NSPIN))
	MBNDEMP=MIN(NBNDEMP(1),NBNDEMP(NSPIN))
C DEFINE # OF FILLED BANDS IF THERE IS SPIN-ORBIT COUPLING
	ELSEIF(NORBS.EQ.2)THEN
	MBNDFIL=0
	DO IBAND=1,NBNDT(1)*NSPIN
	IWINF=0
	DO IPNT=1,NPNT(1)
	IF(EARR(IBAND,IPNT,1).LT.EF-WINDOW)IWINF=IWINF+1
	ENDDO 
	IF(IWINF.EQ.NPNT(1))MBNDFIL=IBAND
	ENDDO
	MBNDEMP=NBNDT(1)*NSPIN+1
	DO IBAND=1,NBNDT(1)*NSPIN
	IWINE=0
	DO IPNT=1,NPNT(1)
	IF(EARR(IBAND,IPNT,1).GT.EF+WINDOW)IWINE=IWINE+1
	ENDDO 
	IF(IWINE.EQ.NPNT(1))MBNDEMP=IBAND
	ENDDO
	IF(MOD(MBNDFIL,2).NE.0)MBNDFIL=MBNDFIL-1
	IF(MOD(MBNDEMP,2).NE.0)MBNDEMP=MBNDEMP+1
	IF(MBNDFIL.LT.0)MBNDFIL=0
	MBNDFIL=MBNDFIL/2
	MBNDEMP=MBNDEMP/2
	ENDIF
	WRITE(IUN,1010)MBNDFIL
	WRITE(IUN,1020)MBNDEMP-MBNDFIL-1
1010    FORMAT(1X,'LR information: # of fully filled bands (nff) =',I4)
1020    FORMAT(1X,'LR information: # of bands crossing  EF (nef) =',I4)
	END
