	SUBROUTINE NMTFILE           
************************************************************
*  <NMTFILE> checks file storage.                          *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,ILSV(NSORTMAX),NHSORT(NSORTMAX)
	CHARACTER*60 INIFILE,SC0FILE,STRFILE,SCRFILE(100)
     &   ,HUBFILE,HOPFILE,OPTFILE,ENRFILE,PNTFILE,TXTSCR
     &   ,CONFILE,FTRFILE,KOVFILE,PSIFILE,TMPFILE,BNDFILE
     &   ,POTFILE,FATFILE,DOSFILE,SCFFILE,OUTFILE
	CHARACTER TXTEL(NSORTMAX)*10,TXTSP(2)*2,UN(100)*2
        LOGICAL EXIST
C Controls:
	COMMON /CONTROL/ LIFT,LMTO,NCOU,NINT,NPFR            !!! from readini
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from readini
	COMMON /ORBS/    NORBS                               !!! from readini
	COMMON /SPIN/    NSPIN                               !!! from readini
C Additional inputs:
	COMMON /INP0/    INIFILE,SC0FILE,STRFILE             !!! from init
        COMMON /INP1/    ICHUB,ICHOP,ICOPT,ICENR,ICPNT       !!! from readini
        COMMON /INP2/    HUBFILE,HOPFILE,OPTFILE,ENRFILE,PNTFILE                  
C Outputs:
	COMMON /OUT0/    SCRFILE                             !!! from readini
	COMMON /OUT1/    ICCON,ICFTR,ICKOV,ICPSI,ICTMP,ICBND !!! from readini
     &                  ,ICPOT,ICFAT,ICDOS,ICSCF,ICOUT
	COMMON /OUT2/    CONFILE,FTRFILE,KOVFILE,PSIFILE,TMPFILE
     &                  ,BNDFILE,POTFILE,FATFILE,DOSFILE,SCFFILE
     &                  ,OUTFILE
	COMMON /TXTEL/   TXTEL,TXTSP                         !!! from readini
        COMMON /SCRDIR/  TXTSCR                              !!! from block
	COMMON /UNIT/    IUN,IUT,IUR                         !!! from readini
	DATA PI/3.141592653589793D0/                             
        DATA UN/'01','02','03','04','05','06','07','08','09','10'
     &         ,'11','12','13','14','15','16','17','18','19','20'
     &         ,'21','22','23','24','25','26','27','28','29','30'
     &         ,'31','32','33','34','35','36','37','38','39','40'
     &         ,'41','42','43','44','45','46','47','48','49','50'
     &         ,'51','52','53','54','55','56','57','58','59','60'
     &         ,'61','62','63','64','65','66','67','68','69','70'
     &         ,'71','72','73','74','75','76','77','78','79','80'
     &         ,'81','82','83','84','85','86','87','88','89','90'
     &         ,'91','92','93','94','95','96','97','98','99','00'/
C  1. STRUCTURE CONSTANTS
	INQUIRE(FILE=CONFILE,EXIST=EXIST)
	IF(EXIST.AND.ICCON.EQ.1)THEN
	PRINT*,'WARNING FROM <NMTFILE>:: CONFILE  EXIST, WILL BE ',
     &  'CHECKED'
	ICCON=2
	ELSEIF(.NOT.EXIST.AND.ICCON.EQ.2)THEN
	PRINT*,'WARNING FROM <NMTFILE>:: CONFILE  DOES NOT EXIST, ',
     &  'WILL BE CREATED'
	ICCON=1
	ENDIF
C  2. FOURIER CONSTANTS
	INQUIRE(FILE=FTRFILE,EXIST=EXIST)
	IF(EXIST.AND.ICFTR.EQ.1)THEN
	PRINT*,'WARNING FROM <NMTFILE>:: FTRFILE  EXIST, WILL BE ',
     &  'CHECKED'
	ICFTR=2
	ELSEIF(.NOT.EXIST.AND.ICFTR.EQ.2)THEN
	PRINT*,'WARNING FROM <NMTFILE>:: FTRFILE  DOES NOT EXIST, ',
     &  'WILL BE CREATED'
	ICFTR=1
	ENDIF
C  3. WAVE FUNCTIONS
	INQUIRE(FILE=PSIFILE,EXIST=EXIST)
	IF(EXIST.AND.ICPSI.EQ.1)
     &  STOP'<NMTFILE>:: PSIFILE EXIST, DELETE IT !'
C  5. BAND STRUCTURE
	INQUIRE(FILE=BNDFILE,EXIST=EXIST)
	IF(EXIST.AND.ICBND.NE.0)
     &  STOP'<NMTFILE>:: BNDFILE EXIST, DELETE IT !'
	IF(ABS(ICBND).EQ.1.AND.LIFT.EQ.3)LIFT=2
C  6. FULL POTENTIAL
	INQUIRE(FILE=POTFILE,EXIST=EXIST)
	IF(EXIST.AND.ICPOT.EQ.1)THEN
	STOP'<NMTFILE>:: POTFILE EXIST, DELETE IT !'
	ELSEIF(.NOT.EXIST.AND.ICPOT.EQ.2)THEN
	STOP'<NMTFILE>:: POTFILE DOES NOT EXIST !'
	ELSEIF(EXIST.AND.ICPOT.EQ.2)THEN
	PRINT*,'<NMTFILE>:: POTFILE WILL BE READ!'
	ENDIF
C  7. FAT BANDS
	INQUIRE(FILE=FATFILE,EXIST=EXIST)
	IF(EXIST.AND.ICFAT.EQ.1)
     &  STOP'<NMTFILE>:: FATFILE EXIST, DELETE IT !'
C  8. DENSITY OF STATES
	INQUIRE(FILE=DOSFILE,EXIST=EXIST)
	IF(.NOT.EXIST.AND.ICDOS.EQ.1)
     &  STOP'<NMTFILE>:: DOSFILE DOES NOT EXIST, MUST BE CREATED'
C  9. FULL CHARGE DENSITY 
	INQUIRE(FILE=SCFFILE,EXIST=EXIST)
	IF(EXIST.AND.ICSCF.EQ.1)THEN
	STOP'<NMTFILE>:: SCFFILE EXIST, DELETE IT !'
	ELSEIF(EXIST.AND.ICSCF.EQ.2)THEN
	OPEN(UNIT=1,FILE=SCFFILE,FORM='UNFORMATTED',
     &  STATUS='OLD')
	NA=INDEX(SCFFILE,' ')
	PRINT*,SCFFILE(:NA-1),' DELETED !'
	CLOSE(UNIT=1,STATUS='DELETE')
	ENDIF
C 10. OUTPUT FILE
        INQUIRE(FILE=OUTFILE,EXIST=EXIST)
        IF(EXIST.AND.ICOUT.EQ.1)THEN
        STOP'<NMTFILE>:: OUTFILE EXIST, DELETE IT !'
        ELSEIF(EXIST.AND.ICOUT.EQ.2)THEN
        OPEN(UNIT=1,FILE=OUTFILE,FORM='UNFORMATTED',
     &  STATUS='OLD')
        NA=INDEX(OUTFILE,' ')
        PRINT*,OUTFILE(:NA-1),' DELETED !'
        CLOSE(UNIT=1,STATUS='DELETE')
        ENDIF
        IF(ICOUT.NE.IUT)THEN
        IUN=2
        OPEN(UNIT=2,FILE=OUTFILE,STATUS='NEW')
        ELSE
        IUN=IUT
        ENDIF
C  SET SCRATCH STORAGE FILENAMES
        NA=INDEX(SCRFILE(1),' ')
        NS=INDEX(TXTSCR,' ')
        DO I=2,100
        SCRFILE(I)=TXTSCR(:NS-1)//SCRFILE(1)(:NA-1)//UN(I)
        ENDDO
        SCRFILE(1)=TXTSCR(:NS-1)//SCRFILE(1)(:NA-1)//UN(1)
        DO I=1,100
        INQUIRE(FILE=SCRFILE(I),EXIST=EXIST)
        IF(EXIST)THEN
        OPEN(UNIT=1,FILE=SCRFILE(I),FORM='UNFORMATTED',
     &  STATUS='OLD')
        NA=INDEX(SCRFILE(I),' ')
        PRINT*,SCRFILE(I)(:NA-1)//' DELETED !'
        CLOSE(UNIT=1,STATUS='DELETE')
        ENDIF
        ENDDO
	END
