	SUBROUTINE PRINT2
***********************************************
*  Print data on the potential and density    *
***********************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),ISPL(NSORTMAX)
     &    ,NRAD(NSORTMAX)
	COMPLEX*16 V(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
     &    ,AMTOT(NSYMMAX,NPAT,NSPINMAX)
	DIMENSION SMT(NSORTMAX),VMT(NSORTMAX,NSPINMAX),ORTH(2:3)
     &   ,VSF(NSORTMAX,NSPINMAX),Z(NSORTMAX),ZCOR(NSORTMAX)
     &   ,VSPH(0:NRADMAX,NSORTMAX,NSPINMAX),SPLIT(NSORTMAX)
     &   ,TAU(3,NPAT),ROCOR(0:NRADMAX,NSORTMAX,NSPINMAX)
	CHARACTER TXTEL(NSORTMAX)*10,TXTSP(2)*2
	COMMON /CONTROL/MAN,LMTO,NLR,NOVR                   !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /POTCOM/ SWZ,SMT,VSPH,V                      !!! from vfull
	COMMON /BASIS/  TAU                                 !!! from init
	COMMON /RADMESH/NRAD                                !!! from radmsh
	COMMON /DENS/   RO,ROVALDS,ROCOR                    !!! from rofull
	COMMON /VZERO/  VMT0,VMT,VSF0,VSF,VAV               !!! from vzero
	COMMON /MULTRO/ Z,ZCOR,AMTOT                        !!! from multro
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                     !!! from init
	COMMON /SPIN/   NSPIN,SPLIT,ISPL                    !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /TXTEL/  TXTEL,TXTSP                         !!! from init
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
C  PRINT POTENTIAL AND DENSITY DATA
	AMTS=0.D0
	QTOT=0.D0
	DO 20 IATOM=1,NATOM
	ISORT=IS(IATOM)
	WRITE(IUN,1000)TXTEL(ISORT),IATOM
	DO 10 ISPIN=1,NSPIN
C  POTENTIAL AND DENSITY AT THE SPHERE
	IF(NSPIN.EQ.1)
     &  WRITE(IUN,1010)
     &  DREAL(V(NRAD(ISORT),1,IATOM,ISPIN))/SQPI4+VMT0,
     &  DREAL(RO(NRAD(ISORT),1,IATOM,ISPIN))/SQPI4
	IF(NSPIN.EQ.2)WRITE(IUN,1020)TXTSP(ISPIN),
     &  DREAL(V(NRAD(ISORT),1,IATOM,ISPIN))/SQPI4+VMT0,
     &  TXTSP(ISPIN),DREAL(RO(NRAD(ISORT),1,IATOM,ISPIN))/SQPI4
   10   CONTINUE
	AMTS=AMTS+DREAL(AMTOT(1,IATOM,1)-AMTOT(1,IATOM,NSPIN))
	QTOT=QTOT+(DREAL(AMTOT(1,IATOM,1)+AMTOT(1,IATOM,NSPIN)))/
     &  2.D0*DBLE(NSPIN)
C  PRINT MAGNETISATION
	IF(NSPIN.EQ.2)THEN
	IF(ABS(SPLIT(IS(IATOM))).LT.1.D-10)
     &	WRITE(IUN,1030)DREAL(AMTOT(1,IATOM,1)-AMTOT(1,IATOM,NSPIN)),0.D0
	IF(ABS(SPLIT(IS(IATOM))).GE.1.D-10)
     &  WRITE(IUN,1030)DREAL(AMTOT(1,IATOM,1)-AMTOT(1,IATOM,NSPIN)),
     &                 DREAL(AMTOT(1,IATOM,1)-AMTOT(1,IATOM,NSPIN))/
     &  SPLIT(ISORT)
	ENDIF
  20    CONTINUE
	WRITE(IUN,1110)VMT0
	WRITE(IUN,1120)VSF0
	WRITE(IUN,1130)0.D0
	WRITE(IUN,1140)QTOT
	IF(NSPIN.EQ.2)WRITE(IUN,1150)AMTS
1000  FORMAT(1X,'Input data ',A10,' in the position ',I3,' ------->')
1010  FORMAT(1X,'   V(S)=',G14.7,'  |     RO(S)=',G14.7)
1020  FORMAT(1X,'V-',A2,'(S)=',G14.7,'  | RO-',A2,'(S)=',G14.7)
1030  FORMAT(1X,'   M(S)=',G14.7,'  |    HI(S)=',G14.7)
1110  FORMAT(' Average potential over the sphere boundaries is ',G14.7)
1120  FORMAT(' Average potential in the interstitial region is ',G14.7)
1130  FORMAT(' Total charge  in the  elementary cell  must  be ',G14.7)
1140  FORMAT(' Total charge  found  in  the elementary cell is ',G14.7)
1150  FORMAT(' Total magnetization found in elementary cell is ',G14.7)
	RETURN
	END



	SUBROUTINE PRINTC(KEY)
*******************************************************
*  Prints input-output charge.                        *
*******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSV(NSORTMAX),ILSB(NSORTMAX)
	COMPLEX*16 SMTINP(NPAT),SMTOUT(NPAT),AMTINP(NPAT),AMTOUT(NPAT)
     &   ,AMTOT(NSYMMAX,NPAT,NSPINMAX)
	DIMENSION Z(NSORTMAX),ZCOR(NSORTMAX),ORTH(2:3)
	CHARACTER TXTEL(NSORTMAX)*10
	COMMON /CONTROL/LIFT,LMTO,NCOU,NOVR,NPF                 !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM           !!! from init
	COMMON /MULTRO/ Z,ZCOR,AMTOT                            !!! from multro
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                         !!! from init
	COMMON /SPIN/   NSPIN                                   !!! from init
	COMMON /TXTEL/  TXTEL                                   !!! from init
	COMMON /UNIT/   IUN                                     !!! from init
	SAVE SMTINP,SININP,AMTINP,AMTOUT
	DATA PI/3.141592653589793D0/
C  SAVE INPUT CHARGE TRANSFER
	IF(KEY.EQ.1)THEN
	DO 10 IATOM=1,NATOM
	SMTINP(IATOM)=(AMTOT(1,IATOM,1)+AMTOT(1,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)
	AMTINP(IATOM)=AMTOT(1,IATOM,1)-AMTOT(1,IATOM,NSPIN)
   10   CONTINUE
	ELSEIF(KEY.EQ.2)THEN
	DO 20 IATOM=1,NATOM
	SMTOUT(IATOM)=(AMTOT(1,IATOM,1)+AMTOT(1,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)
	AMTOUT(IATOM)=AMTOT(1,IATOM,1)-AMTOT(1,IATOM,NSPIN)
   20   CONTINUE
C  PRINT CELL CHARGES
	WRITE(IUN,1010)
	WRITE(IUN,1020)
	DO 30 IATOM=1,NATOM
	WRITE(IUN,1030)DREAL(SMTINP(IATOM)),DREAL(SMTOUT(IATOM)),
     &  TXTEL(IS(IATOM))
   30   CONTINUE
	IF(NSPIN.EQ.2)THEN
	WRITE(IUN,1040)
	WRITE(IUN,1050)
	DO 40 IATOM=1,NATOM
	WRITE(IUN,1030)DREAL(AMTINP(IATOM)),DREAL(AMTOUT(IATOM)),
     &  TXTEL(IS(IATOM))
   40   CONTINUE
	ENDIF
	WRITE(IUN,1060)
	ENDIF
1010    FORMAT(1X,'Input/output charge transfer at the iteration  --->')
1020    FORMAT(1X,'    S(inp)              S(out)')
1030    FORMAT(1X,G14.7,6X,G14.7,2X,A)
1040    FORMAT(1X,'Input/output magnetic moment at the iteration  --->')
1050    FORMAT(1X,'    M(inp)              M(out)')
1060    FORMAT(63('*'))
	END
