	SUBROUTINE SCRCON
******************************************************************* 
*  Calculates screened structure constants in real space using    *
*  inversion method.                                              *
*  S.Savrasov, MPI,Stuttgart. Created 02.03.93, Revised 02.03.93. *
*******************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,NKAP(NPANMAX),ILSV(NSORTMAX),NENV(NPAT)
     &    ,ISENV(0:NENVMAX,NPAT),NENV0(NPAT)
     &    ,ICENV(0:NENVMAX,0:NENVMAX,NPAT)
     &    ,IPENV(0:NENVMAX,NPAT,NOPRMAX)
     &    ,IRENV(0:NENVMAX,NPAT)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &    ,TMAT(LIMLMB*(NENVMAX+1),LIMLMB*(NENVMAX+1))
     &    ,SCRSS(LIMLMT,0:NENVMAX,LIMLMB),EK0(NKAPMAX)
     &    ,ALPDOT(0:LMAXT,0:NSORTMAX,NKAPMAX,NPANMAX)
     &    ,ALPHA(0:LMAXT,0:NSORTMAX,NKAPMAX,NPANMAX)
     &    ,DLOG(0:LMAXT,0:NSORTMAX,NKAPMAX,NPANMAX)
     &    ,WORKS(LIMLMB,0:NENVMAX,LIMLMB,NPAT)
     &    ,WORKD(LIMLMB,0:NENVMAX,LIMLMB,NPAT)
     &    ,SCRSD(LIMLMB,0:NENVMAX,LIMLMB)
     &    ,SBARE(LIMLMT,LIMLMB,0:NENVMAX)
     &    ,SBDOT(LIMLMB,LIMLMB,0:NENVMAX)
     &    ,WORK (LIMLMB,0:NENVMAX,LIMLMB)
     &    ,EXPKR,KAPPA,EXPDT,SUMRUL(2,NPAT)
	DIMENSION RBAS(3,3),TAU(3,NPAT),TENV(3,0:NENVMAX,NPAT)
     &    ,RLOC(NSORTMAX),SMT(NSORTMAX),TAUT(3,NPAT)
     &    ,WRK(LIMLMB*(NENVMAX+1))
	CHARACTER CONFILE*60,SCRFILE(100)*60,TXTEL(NSORTMAX)*10
	LOGICAL FIRST
C Controls:
	COMMON /CONTROL/LIFT,LMTO                           !!! from readini
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from readini
C Inputs:
	COMMON /POTCOM/ SWZ,SMT                             !!! from readini
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                   !!! from readini
C Lattice:
	COMMON /LATTICE/RBAS                                !!! from readstr
	COMMON /BASIS/  TAU                                 !!! from readstr
C Screening data:
	COMMON /SCRINP/ RLOC,ALPHA,ALPDOT,DLOG              !!! from alpcon
	COMMON /ENVSITE/NENV,TENV,ISENV,IPENV,IRENV,ICENV   !!! from scrcon
C Temporary storage:
	COMMON /DENS/   WORKS,WORKD,SBARE,SBDOT             !!! tmp.storage
	COMMON /STORE1/ TMAT                                !!! tmp.storage
	COMMON /STORE2/ SCRSS,SCRSD,WORK                    !!! from scrcon     
C Outputs:
	COMMON /OUT0/   SCRFILE                             !!! from readini
	COMMON /OUT1/   ICON                                !!! from readini
	COMMON /OUT2/   CONFILE                             !!! from readini
	COMMON /TXTEL/  TXTEL                               !!! from readini
	COMMON /UNIT/   IUN                                 !!! from readini
	COMMON /WORD/   NVAL                                !!! from setup
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./
	IF(LMTO.NE.3)RETURN
C OPEN CONFILE FOR STORING TB-STRUCTURE CONSTANTS
	NRECL=0
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	ILSM=ILST(ISORT)
	NRECL=MAX(NRECL,NVAL*((ILSM+1)**2*(ILSB(ISORT)+1)**2+
     &  (ILSB(ISORT)+1)**4)+2*NVAL)
	ENDDO
	IF(ICON.EQ.0)THEN
	OPEN(24,FILE=SCRFILE(24),STATUS='NEW',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NRECL) 
	WRITE(24,REC=1)NRECL,LMTO,NATOM,(NENV(IATOM),IATOM=1,NATOM),
     &  NKAP(1),(EK(IKAP,1),IKAP=1,NKAP(1))
	ELSEIF(ICON.EQ.1)THEN
	OPEN(24,FILE=CONFILE,STATUS='NEW',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NRECL) 
	WRITE(24,REC=1)NRECL,LMTO,NATOM,(NENV(IATOM),IATOM=1,NATOM),
     &  NKAP(1),(EK(IKAP,1),IKAP=1,NKAP(1))
	ELSEIF(ICON.EQ.2)THEN
	INQUIRE(FILE=CONFILE,RECL=NRECL)
CWRONG  IF(WRONG)THEN           !!! wrong compiler statement
	NRECL=NVAL
	OPEN(24,FILE=CONFILE,STATUS='OLD',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NRECL) 
	READ(24,REC=1)NRECL
	CLOSE(24)
CWRONG  ENDIF   
	OPEN(24,FILE=CONFILE,STATUS='OLD',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NRECL) 
	READ(24,REC=1)NRECL,LMTO0,NATOM0,(NENV0(IATOM),IATOM=1,NATOM0),
     &  NKAP0,(EK0(IKAP),IKAP=1,NKAP0)
	IF(LMTO.NE.LMTO0)STOP
     &  '<SCRCON>: BARE STRUCTURE CONSTANTS FOUND IN CONFILE'
	IF(NATOM.NE.NATOM0)STOP
     &  '<SCRCON>: # OF ATOMS MISMATCHES IN CONFILE'
	IF(NKAP(1).NE.NKAP0)STOP
     &  '<SCRCON>: # OF KAPPA"S MISMATCHES IN CONFILE'
	DO IKAP=1,NKAP(1)
	IF(ABS(EK(IKAP,1)-EK0(IKAP)).GE.1.D-10)STOP
     &  '<SCRCON>: TAIL ENERGIES MISMATCH IN CONFILE'
	ENDDO
	DO IATOM=1,NATOM
	IF(NENV(IATOM).NE.NENV0(IATOM))STOP
     &  '<SCRCON>: # OF ENVIRONMENT VECTORS MISMATCHES IN CONFILE'
	ENDDO
	ENDIF
C ***** DO GLOBALLY OVER ENERGIES AND ATOMS IN CELL FOR THE FIRST PANEL *****
	IRECORD=1
	DO 5000 IKAP=1,NKAP(1)                    !!! over energies
	IF(ICON.EQ.2)GOTO2000
	DO 1000 IATOM=1,NATOM                     !!! over atoms
	ISORT=IS(IATOM)
C STEP 1. GENERATE MATRIX TO BE INVERTED
        IND1=0
        DO IENV1=0,NENV(IATOM)                    !!! over ienv1
        IATOM1=ISENV(IENV1,IATOM)
        ISORT1=IS(IATOM1)
        DO IENV2=0,NENV(IATOM)
        IATOM2=ISENV(IENV2,IATOM)
        TX=TENV(1,IENV2,IATOM)-TENV(1,IENV1,IATOM)
        TY=TENV(2,IENV2,IATOM)-TENV(2,IENV1,IATOM)
        TZ=TENV(3,IENV2,IATOM)-TENV(3,IENV1,IATOM)
        CALL BARCON(IKAP,1,IATOM1,IATOM2,TX,TY,TZ,
     &  SBARE(1,1,IENV2),SBDOT(1,1,IENV2))
	ENDDO
        DO L1=0,ILSB(ISORT1)                      !!! over l1
        DO M1=-L1,L1                              !!! over m1
        L1M1=L1*(L1+1)+M1+1
        IND1=IND1+1
        IND2=0
        DO IENV2=0,NENV(IATOM)                    !!! over ienv2
        IATOM2=ISENV(IENV2,IATOM)
        ISORT2=IS(IATOM2)
        DO L2=0,ILSB(ISORT2)                      !!! over l2
        DO M2=-L2,L2                              !!! over m2
        L2M2=L2*(L2+1)+M2+1
        IND2=IND2+1
        TMAT(IND1,IND2)=-ALPHA(L1,ISORT1,IKAP,1)*
     &  SBARE(L1M1,L2M2,IENV2)*ALPHA(L2,ISORT2,IKAP,1)
	ENDDO                                     !!! over m2
        ENDDO                                     !!! over l2
        ENDDO                                     !!! over ienv2
        TMAT(IND1,IND1)=TMAT(IND1,IND1)+ALPHA(L1,ISORT1,IKAP,1)
        ENDDO                                     !!! over m1
        ENDDO                                     !!! over l1
        ENDDO                                     !!! over ienv1
	NDIM=IND1
C STEP 2. INVERT MATRIX
        DO IDIM=1,NDIM
        DO JDIM=1,NDIM
        A=ABS(TMAT(IDIM,JDIM)-CONJG(TMAT(JDIM,IDIM)))
        IF(A.GT.1.D-10)PRINT*,IDIM,JDIM,A
	ENDDO
	ENDDO
	CALL CINV(NDIM,TMAT,LIMLMB*(NENVMAX+1),WRK,IFAIL)
	IF(IFAIL.NE.0)STOP'<SCRCON>:: ERROR IN INVERSION PROGRAM'
C STEP 3. GENERATE SCREENED STRUCTURE CONSTANTS (IN HERMITIAN FORM)
        DO L=0,ILSB(ISORT)                        !!! over l
        DO M=-L,L                                 !!! over m
        LM=L*(L+1)+M+1
        IND1=0
        DO IENV1=0,NENV(IATOM)                    !!! over ienv1
        IATOM1=ISENV(IENV1,IATOM)
        ISORT1=IS(IATOM1)
        DO L1=0,ILSB(ISORT1)                      !!! over l1
        DO M1=-L1,L1                              !!! over m1
        L1M1=L1*(L1+1)+M1+1
        IND1=IND1+1
        WORKS(L1M1,IENV1,LM,IATOM)=TMAT(IND1,LM)
        ENDDO                                     !!! over m1
        ENDDO                                     !!! over l1
        ENDDO                                     !!! over ienv1
        WORKS(LM,0,LM,IATOM)=WORKS(LM,0,LM,IATOM)-
     &  1.D0/ALPHA(L,ISORT,IKAP,1)
        ENDDO                                     !!! over m
        ENDDO                                     !!! over l
C STEP 4. GENERATE ENERGY DERIVATIVES OF THE SCREENED STR.CON.
        IND2=0
        DO IENV2=0,NENV(IATOM)                    !!! over ienv2
        IATOM2=ISENV(IENV2,IATOM)
        ISORT2=IS(IATOM2)
        DO IENV3=0,NENV(IATOM)
        IATOM3=ISENV(IENV3,IATOM)
        TX=TENV(1,IENV3,IATOM)-TENV(1,IENV2,IATOM)
        TY=TENV(2,IENV3,IATOM)-TENV(2,IENV2,IATOM)
        TZ=TENV(3,IENV3,IATOM)-TENV(3,IENV2,IATOM)
        CALL BARCON(IKAP,1,IATOM2,IATOM3,TX,TY,TZ,
     &  SBARE(1,1,IENV3),SBDOT(1,1,IENV3))
	ENDDO 
        DO L2=0,ILSB(ISORT2)                      !!! over l2
        DO M2=-L2,L2                              !!! over m2
        L2M2=L2*(L2+1)+M2+1
        IND2=IND2+1
        DO L=0,ILSB(ISORT)                        !!! over l
        DO M=-L,L                                 !!! over m
        LM=L*(L+1)+M+1
        WORK(L2M2,IENV2,LM)=(0.D0,0.D0)
        IND3=0
        DO IENV3=0,NENV(IATOM)                    !!! over ienv3
        IATOM3=ISENV(IENV3,IATOM)
        ISORT3=IS(IATOM3)
        DO L3=0,ILSB(ISORT3)                      !!! over l3
        DO M3=-L3,L3                              !!! over m3
        L3M3=L3*(L3+1)+M3+1
        IND3=IND3+1
        WORK(L2M2,IENV2,LM)=WORK(L2M2,IENV2,LM)+
     &  ALPHA(L2,ISORT2,IKAP,1)*SBDOT(L2M2,L3M3,IENV3)*
     &  ALPHA(L3,ISORT3,IKAP,1)*TMAT(IND3,LM)
        ENDDO                                     !!! over m3
        ENDDO                                     !!! over l3
        ENDDO                                     !!! over ienv3
        ENDDO                                     !!! over m
        ENDDO                                     !!! over l
        ENDDO                                     !!! over m2
        ENDDO                                     !!! over l2
	ENDDO                                     !!! over ienv2
C
        DO L=0,ILSB(ISORT)                        !!! over l
        DO M=-L,L                                 !!! over m
        LM=L*(L+1)+M+1
        IND1=0
        DO IENV1=0,NENV(IATOM)                    !!! over ienv1
        IATOM1=ISENV(IENV1,IATOM)
        ISORT1=IS(IATOM1)
        DO L1=0,ILSB(ISORT1)                      !!! over l1
        DO M1=-L1,L1                              !!! over m1
        L1M1=L1*(L1+1)+M1+1
        WORKD(L1M1,IENV1,LM,IATOM)=(0.D0,0.D0)
        IND1=IND1+1
        IND2=0
        DO IENV2=0,NENV(IATOM)                    !!! over ienv2
        IATOM2=ISENV(IENV2,IATOM)
        ISORT2=IS(IATOM2)
        DO L2=0,ILSB(ISORT2)                      !!! over l2
        DO M2=-L2,L2                              !!! over m2
        L2M2=L2*(L2+1)+M2+1
        IND2=IND2+1
        WORKD(L1M1,IENV1,LM,IATOM)=WORKD(L1M1,IENV1,LM,IATOM)+
     &  TMAT(IND1,IND2)*WORK(L2M2,IENV2,LM)
        WORKD(L1M1,IENV1,LM,IATOM)=WORKD(L1M1,IENV1,LM,IATOM)+
     &  TMAT(IND1,IND2)*ALPDOT(L2,ISORT2,IKAP,1)*
     &  WORKS(L2M2,IENV2,LM,IATOM)
        ENDDO                                     !!! over m2
        ENDDO                                     !!! over l2
        ENDDO                                     !!! over ienv2
        WORKD(L1M1,IENV1,LM,IATOM)=WORKD(L1M1,IENV1,LM,IATOM)-
     &  1.D0/ALPHA(L1,ISORT1,IKAP,1)*ALPDOT(L1,ISORT1,IKAP,1)*
     &  WORKS(L1M1,IENV1,LM,IATOM)
        ENDDO                                     !!! over m1
        ENDDO                                     !!! over l1
        ENDDO                                     !!! over ienv1
        ENDDO                                     !!! over m
        ENDDO                                     !!! over l
1000    CONTINUE                                  !!! over atoms
2000	CONTINUE
        DO 4000 IATOM=1,NATOM                     !!! over atoms
	ISORT=IS(IATOM)
	IF(ICON.EQ.2)GOTO3000
C STEP 5. GENERATE SCREENED STRUCTURE CONSTANTS IN FINAL FORM
        DO IENV1=0,NENV(IATOM)                    !!! over ienv1
        IATOM1=ISENV(IENV1,IATOM)
        ISORT1=IS(IATOM1)
        KENV=ICENV(0,IENV1,IATOM)
C KATOM MUST BE EQUAL TO IATOM
C       KATOM=ISENV(KENV,IATOM1)
        DO L1=0,ILSB(ISORT1)                      !!! over l1
        DO M1=-L1,L1                              !!! over m1
        L1M1=L1*(L1+1)+M1+1
        DO L=0,ILSB(ISORT)                        !!! over l
        DO M=-L,L                                 !!! over m
        LM=L*(L+1)+M+1
        IF(KENV.GE.0)THEN
        SCRSS(L1M1,IENV1,LM)=0.5D0*(WORKS(L1M1,IENV1,LM,IATOM)+
     &  DCONJG(WORKS(LM,KENV,L1M1,IATOM1)))
        SCRSD(L1M1,IENV1,LM)=0.5D0*(WORKD(L1M1,IENV1,LM,IATOM)+
     &  DCONJG(WORKD(LM,KENV,L1M1,IATOM1)))
        ELSE
        SCRSS(L1M1,IENV1,LM)=WORKS(L1M1,IENV1,LM,IATOM)
        SCRSD(L1M1,IENV1,LM)=WORKD(L1M1,IENV1,LM,IATOM)
        ENDIF
	ENDDO                                     !!! over m1
        ENDDO                                     !!! over l1
        ENDDO                                     !!! over ienv1
        ENDDO                                     !!! over m
        ENDDO                                     !!! over l
C STEP 6. EXPAND SCREENED STRUCTURE CONSTANTS FOR HIGHER L'S
        IND1=0
        DO IENV1=0,NENV(IATOM)                    !!! over ienv1
        IATOM1=ISENV(IENV1,IATOM)
        ISORT1=IS(IATOM1)
        DO IENV2=0,NENV(IATOM)
        IATOM2=ISENV(IENV2,IATOM)
        TX=TENV(1,IENV2,IATOM)-TENV(1,IENV1,IATOM)
        TY=TENV(2,IENV2,IATOM)-TENV(2,IENV1,IATOM)
        TZ=TENV(3,IENV2,IATOM)-TENV(3,IENV1,IATOM)
        CALL BARCON(IKAP,1,IATOM1,IATOM2,TX,TY,TZ,
     &  SBARE(1,1,IENV2),SBDOT(1,1,IENV2))
        ENDDO    
        DO L1=ILSB(ISORT1)+1,ILST(ISORT1)         !!! over l1
        DO M1=-L1,L1                              !!! over m1
        L1M1=L1*(L1+1)+M1+1
        IND1=IND1+1
        DO L=0,ILSB(ISORT)                        !!! over l
        DO M=-L,L                                 !!! over m
        LM=L*(L+1)+M+1
        IND2=0
        SCRSS(L1M1,IENV1,LM)=SBARE(L1M1,LM,0)
        DO IENV2=0,NENV(IATOM)                    !!! over ienv2
        IATOM2=ISENV(IENV2,IATOM)
        ISORT2=IS(IATOM2)
        DO L2=0,ILSB(ISORT2)                      !!! over l2
        DO M2=-L2,L2                              !!! over m2
        L2M2=L2*(L2+1)+M2+1
        SCRSS(L1M1,IENV1,LM)=SCRSS(L1M1,IENV1,LM)+
     &  SBARE(L1M1,L2M2,IENV2)*ALPHA(L2,ISORT2,IKAP,1)*
     &  SCRSS(L2M2,IENV2,LM)
        ENDDO                                     !!! over m2
        ENDDO                                     !!! over l2
        ENDDO                                     !!! over ienv2
        ENDDO                                     !!! over m
        ENDDO                                     !!! over l
        ENDDO                                     !!! over m1
        ENDDO                                     !!! over l1
        ENDDO                                     !!! over ienv1
C  STORE/READ STRUCTURE CONSTANTS
3000	CONTINUE
	DO IENV=0,NENV(IATOM)
	JATOM=ISENV(IENV,IATOM)
	JSORT=IS(JATOM)
	LIM2T=(ILST(JSORT)+1)**2
	LIM2B=(ILSB(ISORT)+1)**2
	IRECORD=IRECORD+1
	IREC=IRECORD
	IF(ICON.NE.2)
     &	WRITE(24,REC=IREC)LIM2T,LIM2B,
     &  ((SCRSS(L1M1,IENV,LM),L1M1=1,LIM2T),LM=1,LIM2B),
     &  ((SCRSD(L1M1,IENV,LM),L1M1=1,LIM2B),LM=1,LIM2B)
	IF(ICON.EQ.2)
     &	READ(24,REC=IREC)LIM2T,LIM2B,
     &  ((SCRSS(L1M1,IENV,LM),L1M1=1,LIM2T),LM=1,LIM2B),
     &  ((SCRSD(L1M1,IENV,LM),L1M1=1,LIM2B),LM=1,LIM2B)
	ENDDO 
C  STEP 7. CHECK FOR SUM RULES FOR SCREENED STRUCTURE CONSTANTS
        SUMRUL(1,IATOM)=(0.D0,0.D0)
        SUMRUL(2,IATOM)=(-1.D0,0.D0)
        DO IENV1=0,NENV(IATOM)                    !!! over ienv1
        IATOM1=ISENV(IENV1,IATOM)
        ISORT1=IS(IATOM1)
        ABST=SQRT(TENV(1,IENV1,IATOM)**2+TENV(2,IENV1,IATOM)**2+
     &  TENV(3,IENV1,IATOM)**2)
        KAPPA=SQRT(EK(IKAP,1))
        IF(ABS(KAPPA).LE.1.D-10.OR.ABST.LE.1.D-10)THEN
        EXPKR=(1.D0,0.D0)
        EXPDT=-1.D0/6.D0*ABST**2
        ELSE
        EXPKR=SIN(KAPPA*ABST)/(KAPPA*ABST)
        EXPDT=(COS(KAPPA*ABST)-EXPKR)/2.D0/EK(IKAP,1)
        ENDIF
        SUMRUL(1,IATOM)=SUMRUL(1,IATOM)+ALPHA(0,ISORT1,IKAP,1)*
     &  SCRSS(1,IENV1,1)*SMT(ISORT1)/SMT(ISORT)*EXPKR
        SUMRUL(2,IATOM)=SUMRUL(2,IATOM)+ALPHA(0,ISORT1,IKAP,1)*
     &  SCRSD(1,IENV1,1)*SMT(ISORT1)/SMT(ISORT)+
     &  ALPDOT(0,ISORT1,IKAP,1)*SCRSS(1,IENV1,1)*
     &  SMT(ISORT1)/SMT(ISORT)+
     &  ALPHA(0,ISORT1,IKAP,1)*SCRSS(1,IENV1,1)*
     &  SMT(ISORT1)/SMT(ISORT)*EXPDT
        ENDDO                                     !!! over ienv1
	WRITE(IUN,1010)(TAU(I,IATOM),I=1,3),TXTEL(IS(IATOM))
	WRITE(IUN,1020)RLOC(ISORT),NENV(IATOM)
	WRITE(IUN,1030)DREAL(EKAP(IKAP,1)),DREAL(SUMRUL(1,IATOM)),
     &  DREAL(SUMRUL(2,IATOM))
C PRINT OUT STRUCTURE CONSTANTS
        WRITE(IUN,1040)
        WRITE(IUN,1050)0.D0,DREAL(SCRSS(1,0,1)),DREAL(SCRSD(1,0,1))
        DO IENV=1,NENV(IATOM)
        ABST=SQRT(TENV(1,IENV,IATOM)**2+TENV(2,IENV,IATOM)**2+
     &  TENV(3,IENV,IATOM)**2)
        IF(ABS(SCRSS(1,IENV,1)-SCRSS(1,IENV-1,1)).GT.1.D-10)
     &  WRITE(IUN,1050)ABST,DREAL(SCRSS(1,IENV,1)),
     &  DREAL(SCRSD(1,IENV,1))
	ENDDO
	WRITE(IUN,1060)(DREAL(DLOG(L,ISORT,IKAP,1)),L=0,ILSB(ISORT))
	WRITE(IUN,1070)(DREAL(ALPHA(L,ISORT,IKAP,1)),L=0,ILSB(ISORT))
	WRITE(IUN,1080)(DREAL(ALPDOT(L,ISORT,IKAP,1)),L=0,ILSB(ISORT))
4000    CONTINUE                                  !!! over atoms
5000    CONTINUE                                  !!! over energies
	CLOSE(24)
	OPEN(24,FILE=CONFILE,STATUS='OLD',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NRECL) 
C Format statements:
1010    FORMAT(1X,'Position : (',G12.5,',',G12.5,',',G12.5,') ',A10)
1020    FORMAT(1X,'cluster size = ',G12.5,'   | nenv = ',I3)
1030    FORMAT(1X,'tail energy  = ',G12.5,' ; s-sum rule =',G14.7,
     &  1X,G14.7)
1040    FORMAT(1X,'&',6X,'|R"-R|',6X,'&',3X,'S^a(R"L"RL)',4X,'&',
     &  1X,'S^a-dot(R"L"RL)',2X,'&')
1050    FORMAT(1X,'&',2X,G14.7,2X,'&',2X,G14.7,2X,'&',2X,G14.7,2X,'&')
1060    FORMAT(1X,'spd log.deriv=',4(1X,G12.5))
1070    FORMAT(1X,'spd scr.alpha=',4(1X,G12.5))
1080    FORMAT(1X,'spd alpha-dot=',4(1X,G12.5))
	END





	SUBROUTINE BARCON(IKAP,IPAN,IATOM,JATOM,TX,TY,TZ,SBARE,SBDOT)
*********************************************************************
*   The calculation of the unscreened (bare) structure constants    *
*   in real space.                                                  *
*   S.Savrasov, MPI, Stuttgart, Created 02.03.93. Revised 02.03.93. *
*********************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (LTLMAX=(LMAXT+1+LMAXB+1)**2,LDLMAX=(2*LMAXB+2)**2)
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NKAP(NPANMAX),NENV(NPAT),ISENV(0:NENVMAX,NPAT)
	COMPLEX*16 SIGMA(LTLMAX),SIGMADOT(LTLMAX)
     &    ,SBARE(LIMLMT,LIMLMB),SBDOT(LIMLMB,LIMLMB)
     &    ,EKAP(NKAPMAX,NPANMAX),HAN(3,0:LMAXT+LMAXB+1)
     &    ,KAPPA,KAPPADOT,KAP,EK(NKAPMAX,NPANMAX),HANM1
     &    ,DIM,DIML,COEF,COEFDOT,YLM(LTLMAX),HANDOT,HT
	DIMENSION C(0:LMAXV+1,LMMAXV1,LMMAXV1),SMT(NSORTMAX)
     &    ,GGNT(0:LMAXV+1,0:LMAXV+1,0:LMAXV+1)
	LOGICAL FIRST,LOG
	COMMON /CONTROL/MAN,LMTO,NLR,NINT                       !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM           !!! from init
	COMMON /POTCOM/ SWZ,SMT                                 !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                       !!! from init
	COMMON /LATPAR/ PAR                                     !!! from init
	COMMON /GAUNT/  C,GGNT                                  !!! from g_data
	COMMON /UNIT/   IUN                                     !!! from init
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./,DIM/(0.D0,1.D0)/
	SQPI4=SQRT(4.D0*PI)
	KAP=SQRT(EK(IKAP,IPAN))
	IF(DREAL(EK(IKAP,IPAN)).LT.0.D0)HT=-(0.D0,1.D0)/
     &  SQRT(EK(IKAP,IPAN))/(SWZ/PAR)
	IF(ABS(EK(IKAP,IPAN)).LE.1.D-10)HT=(1.D0,0.D0)
C  **** DO GLOBALLY OVER ENVIRONMENT VECTORS *****
	JSORT=IS(JATOM)
	ISORT=IS(IATOM)
	ILSMAX=ILST(ISORT)+ILSB(JSORT)
C  FIND LATTICE CONTRIBUTION
	TT=SQRT(TX*TX+TY*TY+TZ*TZ)
	IF(ABS(TT).GE.1.D-10)THEN
	CALL SPHHARM(TX/TT,TY/TT,TZ/TT,ILSMAX,YLM)
	CALL HANKEL(TT,EK(IKAP,IPAN),SWZ/PAR,HAN,ILSMAX)
	IF(DREAL(EK(IKAP,IPAN)).LT.0.D0)HANM1=HT*HAN(1,0)
	IF(ABS(EK(IKAP,IPAN)).LE.1.D-10)HANM1=(1.D0,0.D0)
	IF(DREAL(EK(IKAP,IPAN)).GT.0.D0)HANM1=SIN(KAP*TT)/(KAP*TT) ! Bes(l=0)
	DIML=DIM
	DO L=0,ILSMAX
	IF(L.NE.0)HANDOT=
     &  0.5D0*TT/(SWZ/PAR)/(2.D0*L-1.D0)*HAN(1,L-1)
	IF(L.EQ.0)HANDOT=
     &  0.5D0*TT/(SWZ/PAR)/(2.D0*L-1.D0)*HANM1
	DIML=-DIM*DIML
	COEF=SQPI4*DIML*HAN(1,L)
	COEFDOT=SQPI4*DIML*HANDOT
	DO M=-L,L
	LM=L*(L+1)+M+1
	SIGMA(LM)=COEF*DCONJG(YLM(LM))
	SIGMADOT(LM)=COEFDOT*DCONJG(YLM(LM))
	ENDDO
	ENDDO
	ELSE
	DO L=0,ILSMAX
	DO M=-L,L
	LM=L*(L+1)+M+1
	SIGMA(LM)=(0.D0,0.D0)
	SIGMADOT(LM)=(0.D0,0.D0)
	ENDDO 
	ENDDO 
	ENDIF
C  RESTORE FULL S AND SDOT -MATRICES
	DO L =0,ILSB(JSORT)                       !!! over l
	DO L1=0,ILST(ISORT)                       !!! over l1
	LOG=.FALSE.
	IF(L1.LE.ILSB(ISORT))LOG=.TRUE.
	SOS=(SMT(ISORT)/SWZ)**(L1+0.5)*(SMT(JSORT)/SWZ)**(L+0.5)
	QSOSQ=SQRT(SMT(ISORT)/2.D0/PAR)*SOS*SQRT(SMT(JSORT)/2.D0/PAR)
	SQSOSQS=SWZ/PAR*QSOSQ*SWZ/PAR
	DO M =-L,L                                !!! over m
	LM=L*(L+1)+M+1
	DO M1=-L1,L1                              !!! over m1
	L1M1=L1*(L1+1)+M1+1
	SBARE(L1M1,LM)=(0.0,0.0)
	IF(LOG)SBDOT(L1M1,LM)=(0.0,0.0)
	DO L2=ABS(L-L1),L+L1,2                    !!! over l2
	LL2=L2/2
	M2=M1-M
	L2M2=L2*(L2+1)+M2+1
	IF(ABS(M2).LE.L2)THEN                     !!! over m2
	KAPPA=(1.D0,0.D0)     !!! energies are in units 1/a^2)
	IF(L+L1-L2.NE.0)KAPPA=(SWZ/PAR*KAP)**(L+L1-L2)
	KAPPADOT=(0.D0,0.D0)
	IF(L+L1-L2.NE.0.AND.ABS(EK(IKAP,IPAN)).NE.0.D0)THEN
	KAPPADOT=(L+L1-L2)*0.5D0*(SWZ/PAR*KAP)**(L+L1-L2-2)
	ELSEIF(L+L1-L2.EQ.2.AND.ABS(EK(IKAP,IPAN)).EQ.0.D0)THEN
	KAPPADOT=(1.D0,0.D0)
	ENDIF
	SBARE(L1M1,LM)=SBARE(L1M1,LM)+C(LL2,L1M1,LM)*GGNT(LL2,L1,L)*
     &  SIGMA(L2M2)*QSOSQ*KAPPA
	IF(LOG)
     &  SBDOT(L1M1,LM)=SBDOT(L1M1,LM)+C(LL2,L1M1,LM)*GGNT(LL2,L1,L)*
     &  SIGMADOT(L2M2)*SQSOSQS*KAPPA+C(LL2,L1M1,LM)*GGNT(LL2,L1,L)*
     &  SIGMA(L2M2)*SQSOSQS*KAPPADOT
	ENDIF                          !!! over m2
	ENDDO                          !!! over l2
        ENDDO                          !!! over m1
        ENDDO                          !!! over m
        ENDDO                          !!! over l1
        ENDDO                          !!! over l
	END
