	SUBROUTINE TTRINT1(EF0,TOS,DOS,KEY)
***********************************************************
*  The calculation of the weight functions for integrati- *
*  on over IBZ by means of tetrahedron method.            *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER NHSORT(NSORTMAX),IS(NPAT),NPNT(NPANMAX)
     &   ,ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &	 ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,KCUT(3,4,6),IPQ(0:50,0:50,0:50),KTT(4),NDIV(3)
     &   ,IGQ(0:50,0:50,0:50)
	DIMENSION EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX)
     &   ,E(4),WEIGH(NDIMMAX*NSPINMAX,KMAX),WGT(KMAX,NPANMAX)
     &	 ,WEIGD(NDIMMAX*NSPINMAX,KMAX),AT(4),AD(4)
     &   ,PNT(3,KMAX,NPANMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT	!!! from init
	COMMON /MESH/   NPNT,PNT,WGT               		!!! from ttrmsh
        COMMON /WMESH/  KCUT,IPQ,IGQ                            !!! from bzmesh
	COMMON /ENERGY/ EARR,WEIGH,WEIGD			!!! from lmtbnd
	COMMON /KAPPAR/ NPAN                                    !!! from init
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT			!!! from init
	COMMON /ORBS/   NORBS                                   !!! from init
	COMMON /SPIN/   NSPIN                                   !!! from init
	COMMON /INTTR/  NDIV                                    !!! from init
	COMMON /UNIT/   IUN		        		!!! from init
	DATA PI/3.141592653589793D0/
C *********** INITIALIZATION **************
	EF=EF0
	TOS=0.D0
	DOS=0.D0
	TOT=0.D0
	DOT=0.D0
        VOLIBZ=1.D0
        OT=1.D0/NDIV(1)/NDIV(2)/NDIV(3)/6.D0
C *********** TETRAHEDRON METHOD **********
        DO IBNDS=1,NSPIN
        DO IPNT=1,NPNT(1)
        DO IBNDT=1,NBNDT(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
        WEIGH(IBAND,IPNT)=0.D0
        WEIGD(IBAND,IPNT)=0.D0
	ENDDO
	ENDDO
	ENDDO
        DO I3=0,NDIV(3)-1                    !!! over cells along G3
        DO I2=0,NDIV(2)-1                    !!! over cells along G2
        DO I1=0,NDIV(1)-1                    !!! over cells along G1
C  THE MICROCELL IS SET UP BY I1,I2,I3
C  SET UP TETRAHEDRA INSIDE MICROCELL
        DO ITTR=1,6                          !!! over tetrahedra
        DO I=1,4
C  COORDINATES OF THE TETRAHEDRON AGE GIVEN BY KTT
        J1=I1+KCUT(1,I,ITTR)
        J2=I2+KCUT(2,I,ITTR)
        J3=I3+KCUT(3,I,ITTR)
        KTT(I)=IPQ(J1,J2,J3)
	ENDDO
        DO IBNDS=1,NSPIN                     !!! over spin subbands
        DO IBNDT=1,NBNDT(1)                  !!! over valence bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
        DO I=1,4
        IPNT=KTT(I)
        E(I)=EARR(IBAND,IPNT,1)
	ENDDO
        CALL MCTTRINT0(E,EF,OT,AT,AD,TS,DS,'B','W')
        TOS=TOS+TS
        DOS=DOS+DS
        DO I=1,4
        IPNT=KTT(I)
        WEIGH(IBAND,IPNT)=WEIGH(IBAND,IPNT)+AT(I)
        WEIGD(IBAND,IPNT)=WEIGD(IBAND,IPNT)+AD(I)
        ENDDO        
        ENDDO                                     !!! over valence bands
	ENDDO                                     !!! over spin subbands
        ENDDO                                     !!! over tetrahedra
        ENDDO                                     !!! over N1
        ENDDO                                     !!! over N2
        ENDDO                                     !!! over N3
        DO IBNDS=1,NSPIN
        DO IBNDT=1,NBNDT(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
        DO IPNT=1,NPNT(1)
        WEIGH(IBAND,IPNT)=WEIGH(IBAND,IPNT)/VOLIBZ*2.D0/DBLE(NSPIN)
        WEIGD(IBAND,IPNT)=WEIGD(IBAND,IPNT)/VOLIBZ*2.D0/DBLE(NSPIN)
        TOT=TOT+WEIGH(IBAND,IPNT)
        DOT=DOT+WEIGD(IBAND,IPNT)
	ENDDO
	ENDDO
	ENDDO
C ************ END OF INTEGRATION ***********
	TOS=TOS/VOLIBZ*2.D0/DBLE(NSPIN)
	DOS=DOS/VOLIBZ*2.D0/DBLE(NSPIN)
	IF(KEY.EQ.0)WRITE(IUN,1000)EF,TOS,DOS
	IF(ABS(TOS-TOT).GE.1.D-07)WRITE(IUN,1010)TOS,TOT
	IF(ABS(DOS-DOT).GE.1.D-07)WRITE(IUN,1020)DOS,DOT
1000	FORMAT(' EF,TOS,DOS==',3(1X,G14.7))
1010	FORMAT(' TOS-WEIGHTS MISMATCH :',G14.7,2X,G14.7)
1020	FORMAT(' DOS-WEIGHTS MISMATCH :',G14.7,2X,G14.7)
	RETURN
	END
