	SUBROUTINE ZEROV
***********************************************
*   Set up muffin-tin zero for the potential  *
***********************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),NRAD(NSORTMAX),ISPL(NSORTMAX)
     &   ,LMSYM(LMMAXV,NPAT)
	COMPLEX*16 V(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
	DIMENSION H(NSORTMAX),R(0:NRADMAX,NSORTMAX),Z(NSORTMAX)
     &   ,WEIGHT(0:NRADMAX,NSORTMAX),SPLIT(NSORTMAX),ZCOR(NSORTMAX)
     &   ,VSPH(0:NRADMAX,NSORTMAX,NSPINMAX),DR(0:NRADMAX,NSORTMAX)
     &   ,SMT(NSORTMAX),RL(0:NRADMAX,0:LMAXV,NSORTMAX)
     &   ,VMT(NSORTMAX,NSPINMAX),VSF(NSORTMAX,NSPINMAX)
     &   ,WORK1(0:NRADMAX),WORK2(0:NRADMAX),ORTH(2:3)
	LOGICAL SYM(LMMAXV,NPAT)
	CHARACTER TXTEL(NSORTMAX)*10
C Controls:
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from readini
	COMMON /SPIN/   NSPIN,SPLIT,ISPL                    !!! from readini
        COMMON /RWFCOM/ NRWF,LRWF,IRWF                      !!! from setup
C Inputs:
	COMMON /MULTRO/ Z,ZCOR                              !!! from readini
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                     !!! from readini
	COMMON /SYMMLM/ SYM,LMSYM                           !!! from symlm
C Radial mesh:
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL               !!! from readini
C Potential:
	COMMON /POTCOM/ SWZ,SMT,VSPH,V                      !!! from vfull
	COMMON /VZERO/  VMT0,VMT,VSF0,VSF,VAV0              !!! from vzero
C Outputs:
	COMMON /UNIT/   IUN                                 !!! from readini
	COMMON /TXTEL/  TXTEL                               !!! from readini
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
C  SPLIT THE POTENTIAL FOR SPIN UP AND DOWN IF NECESSARY
        DO ISPIN=1,NSPIN                    !!! over spins
        DO IATOM=1,NATOM                    !!! over atoms
        ISORT=IS(IATOM)
        DO IRAD=1,NRAD(ISORT)               !!! over radial mesh
        V(IRAD,1,IATOM,ISPIN)=V(IRAD,1,IATOM,ISPIN)-
     &  2.D0*Z(ISORT)/R(IRAD,ISORT)*SQPI4
        ENDDO                               !!! over radial mesh
        V(0,1,IATOM,ISPIN)=V(1,1,IATOM,ISPIN)
        DO IRAD=0,NRAD(ISORT)
        V(IRAD,1,IATOM,ISPIN)=V(IRAD,1,IATOM,ISPIN)+
     &  SPLIT(ISORT)/2.D0*SQPI4*(-1)**ISPIN
        ENDDO
        ENDDO                               !!! over atoms
        ENDDO                               !!! over spins
C  SET UP SPLITTING TO ZERO
        DO ISORT=1,NSORT
        IF(ISPL(ISORT).NE.1)SPLIT(ISORT)=0.D0
        ENDDO
C  DEFINE MT-ZERO AND SURFACE ZERO
        VMT0=0.D0
        VSF0=0.D0
        SURFACE=0.D0
        OMEGAM=0.D0
        DO ISPIN=1,NSPIN
        DO ISORT=1,NSORT
        VMT(ISORT,ISPIN)=0.D0
        VSF(ISORT,ISPIN)=0.D0
        DO IATOM=1,NATOM
        IF(IS(IATOM).EQ.ISORT)THEN
        VMT(ISORT,ISPIN)=VMT(ISORT,ISPIN)+
     &  V(NRAD(ISORT),1,IATOM,ISPIN)/SQRT(4.D0*PI)/
     &  DBLE(NHSORT(ISORT))
        ENDIF
        ENDDO
        VSF(ISORT,ISPIN)=VMT(ISORT,ISPIN)
        OMEGAM=OMEGAM+4.D0/3.D0*PI*NHSORT(ISORT)*SMT(ISORT)**3/
     &  DBLE(NSPIN)
        SURFACE=SURFACE+4.D0*PI*NHSORT(ISORT)*SMT(ISORT)**2/DBLE(NSPIN)
        VSF0=VSF0+4.D0*PI*VMT(ISORT,ISPIN)*NHSORT(ISORT)*
     &  SMT(ISORT)**2
        VMT0=VMT0+VMT(ISORT,ISPIN)*NHSORT(ISORT)
        ENDDO
        ENDDO
        VMT0=VMT0/DBLE(NATOM*NSPIN)
        VSF0=VSF0/SURFACE-VMT0
        VAV0=PSVINT/(OMEGAC-OMEGAM)
C  SHIFT POTENTIAL ACOORDING TO NEW ZERO
        DO ISPIN=1,NSPIN
        DO IATOM=1,NATOM
        DO IRAD=0,NRAD(IS(IATOM))
        V(IRAD,1,IATOM,ISPIN)=V(IRAD,1,IATOM,ISPIN)-VMT0*SQPI4
        ENDDO
        ENDDO
        ENDDO
        IF(LRWF.EQ.0)RETURN
C  SET SPHERICAL POTENTIAL FOR CALCULATING RADIAL FUNCTIONS
        DO ISORT=1,NSORT
        DO ISPIN=1,NSPIN
        DO IRAD=0,NRAD(ISORT)
        VSPH(IRAD,ISORT,ISPIN)=0.D0
        ENDDO
        DO IATOM=1,NATOM
        IF(IS(IATOM).EQ.ISORT)THEN
C  Spin-averaged:
        IF(LRWF.EQ.1)THEN
        DO IRAD=0,NRAD(ISORT)
        VSPH(IRAD,ISORT,ISPIN)=VSPH(IRAD,ISORT,ISPIN)-
     &  0.5D0*R(IRAD,ISORT)*V(IRAD,1,IATOM,1    )/SQPI4/
     &  DBLE(NHSORT(ISORT))-
     &  0.5D0*R(IRAD,ISORT)*V(IRAD,1,IATOM,NSPIN)/SQPI4/
     &  DBLE(NHSORT(ISORT))
        ENDDO
C  Spin-dependent:
        ELSEIF(LRWF.EQ.2)THEN
        DO IRAD=0,NRAD(ISORT)
        VSPH(IRAD,ISORT,ISPIN)=VSPH(IRAD,ISORT,ISPIN)-
     &  R(IRAD,ISORT)*V(IRAD,1,IATOM,ISPIN)/SQPI4/
     &  DBLE(NHSORT(ISORT))
        ENDDO
        ENDIF
        ENDIF
        ENDDO
        VSPH(0,ISORT,ISPIN)=2.D0*Z(ISORT)
        ENDDO
        ENDDO
        END
